---
---

{% node_module lunr/lunr.js %}
{% node_module lunr-languages/min/lunr.stemmer.support.min.js %}
{% node_module lunr-languages/min/lunr.es.min.js %}
{% node_module liquidjs/dist/liquid.browser.min.js %}

const loadEvent = () => {
  try {
    if (Turbolinks) return 'turbolinks:load'
  } catch {
    return 'DOMContentLoaded'
  }
}

const renderer = new window.liquidjs.Liquid();

/*
 * Buscar y mostrar los resultados
 */
const q = (_q) => {
  if (!_q || _q === '') return;

  const _results = document.querySelector('main');

  document.querySelector('form.search')
          .querySelector('input[name=q]')
          .value = _q;

  renderer.parseAndRender(
    window.template,
    { results: window.index.search(`${_q}~2`).map(r => window.data.find(a => a.id == r.ref)) })
    .then(html => _results.innerHTML = html);
}

document.addEventListener(loadEvent(), () => {
  /*
   * Solo descargar los datos de búsqueda una vez
   */
  if (!window.data) {
    fetch('data.json').then(res => {
      res.json().then(data => window.data = data);
      fetch('results.liquid').then(r => r.text()).then(t => window.template = t);
      fetch('idx.json').then(res => res.json()).then(idx => window.index = lunr.Index.load(idx));
    });
  }

  /*
   * Buscar
   */
  document.querySelectorAll('form.search').forEach(form => {
    form.addEventListener('submit', event => {
      event.preventDefault();
      event.stopPropagation();

      q(form.querySelector('input[name=q]').value);
    });
  });

  document.querySelectorAll("a[href^='http://'],a[href^='https://'],a[href^='//']").forEach(a => {
    a.rel = "noopener";
    a.target = "_blank";
  });
});
